IXXAT SocketCAN driver for Linux
================================

This directory contains the files to build the SocketCAN driver for the 
USB-to-CAN v2 module.

Note: 
  The driver should work with most Linux distributions running a 2.6.37 or newer, 
  but was only tested using Ubuntu (19.04) running kernel version 5.0.0. 


Building and installing the driver
------------------------------------

1) To build the driver you need to change into the "usb2can" directory and simply run 

   "make"

2) If this was successfull, you can install all the USB kernel modules by typing 

   "sudo make install"

   You can check the result with 

   "dmesg | grep ixxat"

   If driver was loaded properly and there are interfaces connected you see e.g. 

   ixxat_usb2can: loading out-of-tree module taints kernel.
   ixxat_usb2can: module verification failed: signature and/or required key missing - tainting kernel
   usbcore: registered new interface driver ixxat_usb2can
   ixxat_usb2can 1-1:1.0 can0: USB-to-CAN_V2: Connected Channel 0 (device HW425358)

   Now the module is ready to use.


Using SocketCAN
------------------------------------
1) Before you can send and receive data you need to configure 
   the interface. To do this you can use the 'ip' tool. For example if you 
   want to set the bitrate of 1Mbit (1000000 bit) to the can0 interface
   you can do this with

   "sudo ip link set can0 type can bitrate 1000000"

2) Now the bitrate is set and you can start the interface by typing

   "sudo ip link set can0 up"

3) After this you can send and receive data on can0. At the beginning you may
   just want to check some small communications. To do this you could use the
   tools from "can-utils". For example you could try to send data with

   "cansend can0 123#112233"
   
   and receive it with 
   
   "candump can0"
   
   As a prerequisite for this, is a connected and properly configured bus with
   at least two communication partners.
